<template>
  <div class="order-card-payment">
    <FormStatistic
      :is-exist-billing-docs="isExistBillingDocs"
      :payments="paymentsData.payments"
      :order="currentOrder"
    />
    <ObTabs
      v-model="selectedTab"
      :items="tabsItems"
    >
      <TablePayment
        class="payments-table"
        :payments="paymentsData.payments.items || []"
        :order="currentOrder"
      />
      <ComissionTablePayment
        v-if="paymentsData.comissionPayments.items && paymentsData.comissionPayments.items.length"
        class="payments-table"
        :payments="paymentsData.comissionPayments.items"
        :order="currentOrder"
      />
      <AddServiceTablePayment
        v-for="item in paymentsData.addServicesPayments"
        :key="item.number"
        :service="item"
        :order="currentOrder"
        class="payments-table"
      />
    </ObTabs>
  </div>
</template>

<script>
  import { mapGetters } from 'vuex'
  import FormStatistic from './formStatistic'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import TablePayment from './tablePayment/index'
  import ComissionTablePayment from './comissionTablePayment/index'
  import AddServiceTablePayment from './addServiceTablePayment/index'

  export default {
    name: "paymentOrder",
    components: {
      FormStatistic,
      ObTabs,
      TablePayment,
      ComissionTablePayment,
      AddServiceTablePayment
    },
    props: {
      uuid: {
        type: String,
        required: true
      }
    },
    data () {
      return {
        selectedTab: {
          uuid: 'base'
        }
      }
    },
    computed: {
      ...mapGetters({
        order: 'order/order',
        selectedTrip: 'order/selectedTrip',
        selectedSubOrder: 'order/selectedSubOrder',
        subOrder: 'order/subOrder',
        billingInfo: 'order/billingInfo',
      }),
      currentOrder () {
        if (this.uuid === this.order.uuid) {
          return this.order
        } else {
          return this.subOrder[this.uuid] || {}
        }
      },
      accuralCount () {
        return this.paymentsData.payments?.summary?.accrualCount || 0
      },
      tabsItems () {
        return [
          {
            uuid: 'base',
            title: `Начисления ${this.accuralCount}`
          }
        ]
      },
      paymentsData () {
        const billingInfo = this.billingInfo[this.currentOrder.uuid] || {}
        const billingList = billingInfo.billingList || []
        const summary = billingInfo.summary || {}

        const paymentsList = billingList.filter((item) => !['PLATFORM_COMMISSION', 'ADDITIONAL_SERVICE', 'CORRECTION'].includes(item.accrualType))
        const comissionPaymentsList = billingList.filter((item) => item.accrualType === 'PLATFORM_COMMISSION')
        const addServicesPaymentsList = billingList.filter((item) => ['ADDITIONAL_SERVICE', 'CORRECTION'].includes(item.accrualType))

        return {
          payments: {
            summary: summary,
            items: paymentsList
          },
          comissionPayments: {
            summary: summary,
            items: comissionPaymentsList
          },
          addServicesPayments: addServicesPaymentsList
        }
      },
      isExistBillingDocs () {
        return Boolean(this.paymentsData.payments.items.length) || Boolean(this.paymentsData.comissionPayments.items.length) || Boolean(this.paymentsData.addServicesPayments.length)
      }
    }
  }
</script>

<style scoped lang="scss">
  .order-card-payment {
    &-title {
      display: flex;
      letter-spacing: 0.4px;
      &--number {
        color: $color-blue-navy-blue;
        font-weight: bold;
        font-size: 20px;
        line-height: 28px;
        margin-right: 8px;
      }
      &--sub {
        font-size: 12px;
        line-height: 20px;
        font-variant: small-caps;
        color: $color-grey-span;
        text-transform: uppercase;
      }
    }
    .payments-table {
      margin-top: 40px;
      border: 1px $color-grey-border solid;
      border-radius: 3px;
    }
    &::v-deep {
      .table-empty {
        min-height: 100px;
      }
      .none-content-title {
        transform: none!important;
      }
      tr:last-child {
        border-bottom: none;
      }
    }
  }
</style>
